# Custom Loss Function

Tensorleap enables you to write custom loss functions to be used within the platform. Once you define your custom loss function, and add it using  [@tensorleap\_custom\_loss](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_custom_loss.md)**,** you can use it within the platform by adding a **CustomLoss** node.

This function can get multiple np.ndarray arrays which will be exposed in the **CustomLoss** UI connections. These are of shape *(batch, dim-1,...,dim-n)*. \
The function returns a np.ndarray that contains a batch loss.&#x20;

Example of a custom loss function:

<pre class="language-python"><code class="lang-python"><strong>from code_loader.contract.datasetclasses import PreprocessResponse
</strong>from code_loader.inner_leap_binder.leapbinder_decorators import tensorleap_custom_loss
import numpy as np
...

@tensorleap_custom_loss(name='weighted_ce')
def weighted_categorical_crossentropy(y_true :np.ndarray, y_pred: np.ndarray) -> np.ndarray:
    # Normalize predictions so each sample's probabilities sum to 1
    y_pred = y_pred / np.sum(y_pred, axis=-1, keepdims=True)
    
    # Clip predictions to avoid log(0) and ensure numerical stability
    epsilon = 1e-7  # Similar to K.epsilon()
    y_pred = np.clip(y_pred, epsilon, 1 - epsilon)
    
    # Define class weights
    weights = np.array([0.5, 2.1, 3, 4, 4, 4, 4, 4])
    
    # Compute weighted log loss
    loss = y_true * np.log(y_pred) * weights
    loss = -np.sum(loss, axis=-1)
    return loss
</code></pre>

The [@tensorleap\_custom\_loss](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_custom_loss.md) decorator registers each custom loss into the Tensorleap integration.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/writing-integration-code/custom-loss-function.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
